
-module(foob).
-compile([export_all]).


f(0) -> done;
f(N) when N>0 -> f(N-1);
f(N) when N<0 -> neg_arg.


ff(0,A) -> io:fwrite("Did loops: ~p~n",[A]);
ff(N,A) when N>0 -> ff(N-1,A+1);
ff(N,_) when N<0 -> oops_neg_arg.


facto(0) -> 1;
facto(N) -> N * facto(N-1).

fac(0,B) -> B;
fac(N,B) -> fac(N-1,N*B).
	
area({square, Side}) ->
   Side * Side;
area({circle, Radius}) ->
   % almost :-)
   3 * Radius * Radius;
area({triangle, A, B, C}) ->
   S = (A + B + C)/2,
   math:sqrt(S*(S-A)*(S-B)*(S-C));
area(Other) ->
   {invalid_object, Other}.


%defmodule Foob do
%  def f(0), do: :done
%  def f(n) when n > 0, do: f(n - 1)
%  def f(n) when n < 0, do: :neg_arg
%
%  def ff(0, a), do: IO.puts("Did loops: #{a}")
%  def ff(n, a) when n > 0, do: ff(n - 1, a + 1)
%  def ff(n, _), when n < 0, do: :oops_neg_arg
%
%  def facto(0), do: 1
%  def facto(n), do: n * facto(n - 1)
%
%  def fac(0, b), do: b
%  def fac(n, b), do: fac(n - 1, n * b)
%
%  def area({:square, side}), do: side * side
%  def area({:circle, radius}), do: 3 * radius * radius
%  def area({:triangle, a, b, c}) do
%    s = (a + b + c) / 2
%    :math.sqrt(s * (s - a) * (s - b) * (s - c))
%  end
%  def area(other), do: {:invalid_object, other}
%end
%
%# Usage example:
%# Foob.f(5)
%# Foob.ff(5, 0)
%# Foob.facto(5)
%# Foob.fac(5, 1)
%# Foob.area({:square, 5})
%# Foob.area({:circle, 5})
%# Foob.area({:triangle, 3, 4, 5})
%# Foob.area(:invalid)
