
-module(echo).
-compile([export_all]).

go() -> %this is P1
   Pid2 = spawn(?MODULE, eloop, []),

   io:format("~n(P1) sending: ~w~n",[hello]),
   Pid2 ! {self(), hello},
   receive 
      {Pid2, Msg1} ->
         io:format("(P1) echo returned: ~w~n",[Msg1])
   end,

   %io:format("P1 (export?) ~w~n",[Msg1]),

   timer:sleep(2000),

   io:format("~n(P1) sending: ~w~n",[go_heels]),
   Pid2 ! {self(), go_heels},
   receive 
      {Pid2, Msg2} ->
         io:format("(P1) echo sent ~w~n",[Msg2])
   end,

   timer:sleep(2000),

   io:format("~n(P1) sending: ~w~n",[beet_dook]),
   Pid2 ! {self(), beet_dook},
   receive 
      {Pid2, Msg3} ->
         io:format("(P1) echo sent ~w~n",[Msg3])
   end,

   timer:sleep(2000),

   Pid2 ! stop.

eloop() -> % this is P2
   receive
      {From, Msg} -> 
         io:format("(P2) received: ~w~n",[Msg]),
         From ! {self(), Msg},
         eloop();
      stop ->
         true
   end.

